/*
 * ===========================
 * VDK Builder
 * Version 2.0
 * March 2001
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#ifndef _vdkb_FWizard_h_
#define _vdkb_FWizard_h_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif
// vdk support
#include <vdk/vdk.h>

#define FMAX_STEP 1
#define FMAX_ARGS 10

struct SFuncWizard
{
  int access;
  char* rtype;
  char* fname;
  char* vtype[FMAX_ARGS];
  char* vname[FMAX_ARGS];
  bool isValid;
  char* decfile;
  char* deffile;
  char* parent; // parent class
};

// Vdkb_FWizardForm  CLASS
class Vdkb_FWizardForm: public VDKForm
{
 private:
  VDKFrame* steps[FMAX_STEP+1]; 
  int activeStep; 
  SFuncWizard* func; 
  bool SetFunc (char* buff);

// gui object declarations
  void GUISetup(void);

 protected:
  VDKBox* vbox;
  VDKFrame* frame0;
  VDKBox* vbox0;
  VDKFixed* fixed0;
  VDKEntry* rettype;
  VDKEntry* fname;
  VDKCustomList* varlist;
  VDKCustomButton* addvar;
  VDKCustomButton* delvar;
  VDKEntry* vartype;
  VDKEntry* varname;
  VDKCombo* typecombo;
  VDKFrame* frame1;
  VDKBox* vbox1;
  VDKFixed* fixed1;
  VDKTextView* functext;
  VDKCheckButton* emptydef;
  VDKCustomButton* deffilebtn;
  VDKBox* hbox;
  VDKCustomButton* prev;
  VDKCustomButton* next;
  VDKCustomButton* finish;
  VDKCustomButton* cancel;
  void OnShow(VDKForm* sender);
  bool CanClose();

public:
  Vdkb_FWizardForm(VDKForm* owner, char* title, SFuncWizard* func = NULL);
  ~Vdkb_FWizardForm();
  void Setup(void);

DECLARE_SIGNAL_MAP(Vdkb_FWizardForm);
  bool OnvarlistSelectRow(VDKObject* sender);
  bool OndelvarClick(VDKObject* sender);
  bool OnvartypeChanged(VDKObject* sender);
  bool OnaddvarClick(VDKObject* sender);
  bool OnprevClick(VDKObject* sender);
  bool OnnextClick(VDKObject* sender);
  bool OnfinishClick(VDKObject* sender);
  bool OncancelClick(VDKObject* sender);
  bool OnemptydefToggled(VDKObject* sender);
  bool OndeffilebtnClick(VDKObject* sender);
//  bool OntypecomboRealize(VDKObject* sender);

DECLARE_SIGNAL_LIST(Vdkb_FWizardForm);
DECLARE_EVENT_LIST(Vdkb_FWizardForm);
// declares two static used to initialize
// form display type and initial position
 static GtkWindowType Vdkb_FWizardForm::DisplayType;
 static GtkWindowPosition Vdkb_FWizardForm::InitialPosition;
};


#endif // _vdkb_FWizard_h_
