/*
 * ===========================
 * VDK Builder
 * Version 0.1
 * Revision 0.0
 * November 1998
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library 
 * Copyright (C) 1998, Mario Motta <mmotta@guest.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#ifndef _vdkb_ccpane_h_
#define _vdkb_ccpane_h_

#include <vdkb2/vdkb_ccproj.h>
#include <vdk/vdk.h>
#include <vdkb2/vdkb_nicebuttonbar.h>
#include "pixmaps/class.xpm"

class VDKBProjectManager;

class VDKBCCPane : public VDKBox
{
  //VDKToolbar *toolbar;
  VDKNiceButtonBar *toolbar;
  VDKPanelbar *bar;
  VDKCustomTree *class_tree;
  VDKMenu* popmenu;
  VDKMenuItem *declared_item,*defined_item;
 protected:
  VDKBProjectManager *owner;
  VDKBCCProject proj;
  char** get_func_image( const char* fname, const char* cname);
//  void AddMember(char* class_name);
 public:
  VDKBCCPane( VDKBProjectManager *owner);
  ~VDKBCCPane() {}
  void Setup();

  VDKBProjectManager* get_owner(){ return owner;}
  VDKCustomTree* get_tree(){ return class_tree;}
  VDKBCCProject get_project(){ return proj;}

  void LoadClassTree(const char* dir);
  void Clean(){ proj.Clean();}
  void EditFile( const char* fname, int lnum);

  void on_update();
  void reset_pane();
  void reload_tree();

  // events
  bool OnSelectRow(VDKObject *sender);
  bool HandleToolbar(VDKObject *sender);
  bool ClassBrowserButtonPress(VDKObject* sender, GdkEvent* event);
  bool JumpToSources(VDKObject* sender);
  DECLARE_SIGNAL_MAP(VDKBCCPane);
  DECLARE_EVENT_LIST(VDKBCCPane);
  DECLARE_SIGNAL_LIST(VDKBCCPane);
};

#endif // _vdkb_ccpane_h_
